<?php

class Core {

	function getRepList($distro,$version,$dblink) {
		$query =& $dblink->query("SELECT * FROM settings");
		$settings = array();
		while ($query->fetchInto($setting, DB_FETCHMODE_ASSOC)) {
			$settings[stripslashes($setting["opt"])] = stripslashes($setting["optvalue"]);
		};
		$query =& $dblink->query("SELECT * FROM version v JOIN distribution d ON d.dist_id=v.dist_id JOIN dtype p ON d.disttype=p.type_id WHERE v.dist_id='$distro' AND v.version_id='$version'");
		$query->fetchInto($infodist, DB_FETCHMODE_ASSOC);
		$query =& $dblink->query("SELECT * FROM repository r JOIN ver2rep v ON r.rep_id=v.rep_id JOIN version v2 ON v.ver_id=v2.version_id JOIN scheme s ON s.scheme_id=r.scheme_id WHERE v.ver_id='$version' ORDER BY r.rtype_id, r.scheme_id ASC");
		while ($query->fetchInto($resinfo, DB_FETCHMODE_ASSOC)) {
	    		$repscheme = stripslashes($resinfo["scheme"]);
	    
	    		$querysect =& $dblink->query("SELECT * FROM section s JOIN sect2rep r ON s.sect_id=r.sect_id WHERE 
r.rep_id='$resinfo[rep_id]'");
	    		$sections = "";
            		while ($querysect->fetchInto($section,DB_FETCHMODE_ASSOC)) {
                    		$sections .= stripslashes($section["sectname"])." ";
            		}

	    		$repscheme = str_replace("{TYPE}",stripslashes($infodist["type"]),$repscheme);
	    		$repscheme = str_replace("{PROTO}",$settings["proto"],$repscheme);
	    		$repscheme = str_replace("{URL}",$settings["url"],$repscheme);
            		$repscheme = str_replace("{REP}",stripslashes($resinfo["repname"]),$repscheme);
	    		$repscheme = str_replace("{DIST}",stripslashes($infodist["vcodename"]),$repscheme);
	    		$repscheme = str_replace("{SECT}",$sections,$repscheme);
	    
	    		$result .= "# ".stripslashes($resinfo["repdescribe"])."\n".$repscheme."\n\n";
        	}
		return $result;
	}
	
	function getInfo($message,$dblink){
		$answer = array();

		if (preg_match("/linux/i",$message)) {
			$dist_id = 0;
			$dist_info = "";
			$vers_id = 0;
			$vers_info = "";
			$qd =& $dblink->query("SELECT * FROM distribution");
			while ($qd->fetchInto($res, DB_FETCHMODE_ASSOC)) {
				if (preg_match("/".stripslashes($res["distua"])."/i",$message)) {
					$dist_id = $res["dist_id"];
					$dist_info = stripslashes($res["distname"]);
					$qv =& $dblink->query("SELECT * FROM version WHERE dist_id='$dist_id'");
					while($qv->fetchInto($rev, DB_FETCHMODE_ASSOC)) {
						if (preg_match("/".stripslashes($rev["vcodename"])."/i",$message)) {
							$vers_id = $rev["version_id"];
							$vers_info = stripslashes($rev["version"])." &#8220;".stripslashes($rev["vname"])."&#8221;";
						}
					}
				}
			}
			$answer[] = "Linux";
			$answer[] = "Судя по всему у Вас операционная система ";
			if ($dist_id!=0) {
				$answer[] = $dist_id;
				$answer[] = $dist_info;
			}
			if ($vers_id!=0) {
				$answer[] = $vers_id;
				$answer[] = $vers_info;
			}

		} else {
			$answer[] = "unknown";
			$answer[] = "Ресурс рассчитан явно не на Вашу операционную систему!";
		}

		return $answer;
	}

	function getInterfacesList($current,$dblink) {
		$url  = parse_url($current);
		$path = array();
		$path = split("/",$url["path"]);
		$currentIF = str_replace(".php","",$path[count($path)-1]);
		$req =& $dblink->query("SELECT * FROM interfaces WHERE interface NOT LIKE '$currentIF'");
		$iflist = "Интерфейсы: ";
		while ($req->fetchInto($if, DB_FETCHMODE_ASSOC)) {
			$iflist .= "<a href='./".stripslashes($if["interface"]).".php'>".strtolower(stripslashes($if["interfaceinfo"]))."</a>, ";
		}
		$iflist = substr($iflist, 0, strlen($iflist)-2);
		return $iflist;
	}
}

?>
